;================================================================
;
;	proba01.ASM			Prba ASM
;
;	1. rai AVR ASM anyag
;
;		- soronknti komment (; utna minden komment)
;
;		F7: Assemble,		
;		Ctrl+F7: Assemble and Run
;		F11: Step
;
;	FONTOS: A fordt a kis- s nagybetket nem klnbzteti meg.
;
;----------------------------------------------------------------
/*
	Blokkonknti komment ( mint C-ben /*     */)
	VIGYZAT, valamelyik fejlesztkrnyezet nem fogadja el!
-----------------------------------------------------------------
*/
; ===============================================================
; === 1. feladat ================================================
; ASM program alapjai:
;	- bels vltozknak rtket adunk (r01-r15, ill. r16-r31)
;	- bels vltozkkal mveletet vgznk
;	- bels vltozkon manipullunk
;
;	FONTOS: Az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk.
;
; ---------------------------------------------------------------

.include "m128def.inc"	; uC tpus definicis file-ja 

			; Direktvk, beszdes vltozk
.def a=r16		; elnevezem az r16-os regisztert a-nak 
.def b=r17		; elnevezem az r17-os regisztert b-nak

.org	0x0		; kezdcm, innen indul a program, RESET vektor kezdete
	jmp start	; start cimkre elugrik

			; 0x0 cim s a 0x100 cm kztt a megszaktsok vannak
			; ezrt ezt a terletet ki kell hagyni (TILTOTT SV)
.org	0x100
start:
	nop		; nem csinl semmit (NO OPERATION)
	NOP		; nem rzkeny a kis- s nagybets rsmdra a fordt
	nop
	nop

; ---- ---- ---- rtkads ---- kzvetlenl r16-r31 !!! ---- ---- ----
	nop
	ldi r16, 2		; r16-os regiszternek rtket adok, 2 decimlisan
	nop
	LDI r17, 0b00000010	; r17-es regiszternek rtket adok, 2 binrisan
	nop
	ldi r18, 0b_0000_0010	; r18-as regiszternek rtket adok, 2 binrisan (lthat)
	nop
	ldi r19, 0x02		; r19-es regiszternek rtket adok, 2 hexban
	nop
	ldi r20, 02		; r20-as regiszternek rtket adok, 2 oktlisan
	nop

; ---- ---- ---- rtkads ---- kzvetve r01-r15 !!! ---- ---- ----
	nop
	ldi r16, 3		; r16-os regiszternek rtket adok, 3 decimlisan
	nop
	mov r2, r16		; r16=3 rtkt bepakolom r02-be (kzvetve)

; ---- ---- ---- sszeads, Kivons MVELETEK ---- ---- ----
	NOP
	add r16, r17		; egyszer sszeads r16-ban keletkezik az eredmny
	nop
	sub r18, r19		; egyszer kivons   r18-ben keletkezik az eredmny
	nop

; ---- ---- ---- rtk nvelse, rtk cskkentse ---- ---- ----
	inc r16			; r16 rtkt eggyel megnveljk
	inc r16			; r16 rtkt eggyel megnveljk
	inc r16			; r16 rtkt eggyel megnveljk

	dec r16 		; r16 rtkt eggyel cskkentjk
	dec r16 		; r16 rtkt eggyel cskkentjk
	dec r16 		; r16 rtkt eggyel cskkentjk

; ---- ---- ---- nullba s egybe llt utastsok ---- ---- ----
	clr r16			; r16 sszes bit-jt 0-ba lltja
	ser r16			; r16 sszes bit-jt 1-be lltja

; ---- ---- ---- Szorzs MVELET ---- ---- ----
	LDI r16, 4		; r16-ba 4 decimlisan
	nop
	ldi r17, 5		; r17-be 5 decimlisan
	nop
	mul r16, r17		; egyszer szorzs r1-ben (H_Byte) s r0-ban (L_Byte) keletkezik az eredmny (!!!)
	nop

; ---- ---- ---- BITMVELETEK ---- ---- ---- 
	ldi r20, 0b00000101	; r20-ba 5 binrisan
	nop
	lsr r20			; Logical Shift Right
	nop 
	lsl r20			; Logical Shift Left 
	nop

	rol r20			; Rotate LEFT   t. CARRY
	nop
	ror r20			; Rotate RIGHT  t. CARRY
	nop
	clr r20			; BITtrls
	nop


	ldi r20, 0b00000101	; r20-ba  5 binrisan
	ldi r21, 0b00001111	; r20-ba 15 binrisan
	nop

	and	r20, r21	; bitenknti S
	nop
	or	r20, r21	; bitenknti VAGY
	nop
	eor	r20, r21	; bitenknti KIZR VAGY
	nop

	eor	r20, r20	; bitenknti KIZR VAGY (sajt magval is)
	nop

stop:				; itt prg a progi a vgtelensgig
	jmp stop

	
; ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ====
; === 2. feladat ===========================================================

.include "m128def.inc"	; uC tpus definicis file-ja 

.org	0x0		; kezdcm, innen indul a program, RESET vektor kezdete
	jmp start	; start cimkre elugrik
			; 0x0 cim s a 0x100 cm kztt a megszaktsok vannak
			; ezrt ezt a terletet ki kell hagyni (TILTOTT SV)
.org	0x100
start:
	nop		; nem csinl semmit (NO OPERATION)

	ldi r21,  2	;  2 (0x02), pozitv szmot tltnk be
	ldi r22, -2 	; -2 (0xFE), negatv szm KETTES komplemens brzols
			; legfels bit az eljel bit (0:pozitv, 1:negatv) 

	add r21,r22 	; lthat, hogy 2+(-2)=0  (0x00), ELL., mkdik OK

	ldi r23,  2 	; betltnk egy szmot (2)
	neg r23		; -1*  2 =-2 eljelet vltunk (kettes koplemens)
	neg r23		; -1*(-2)= 2 eljelet vltunk (ismt pozitv a szm)

	com r23		; bitenknti negls
	inc r23		; hozzad a szmhoz 1-et, gy manulisan is ellltottuk
			; a negatv szmot kettes koplemensben

	ldi  r24,0xF1	; binrisan bert szm
	swap r24	; fels s als 4 bit csere
	swap r24	; fels s als 4 bit (vissza)csere

	ldi  r25, 3	; r25 regiszterbe 3-at runk
	add  r25,r25	; sajt magval sszeadhat, 2*szorzs (r25+r25=2*r25)

	ldi  r25, 3	; r25 regiszterbe 3-at runk
	sub  r25,r25	; kivonhat sajt magval (r25-r25=0)

	ldi  r25, 3	; r25 regiszterbe 3-at runk
	mul  r25,r25	; sajt magval szorozhat,  ngyzetre emels (r25*r25=r25^2)

stop:			; itt prg a progi a vgtelensgig
	jmp stop


; ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ====
; === 3. feladat ===========================================================
;	- Irjon egy programot, mely 2 darab egyenknt 2 Byte-os szmot sszead
;	- Nzze meg, hogy hol kpzdik az eredmny s rtkelje azt
;	- Prblja ki klnbz rtkekkel
; --------------------------------------------------------------------------
.include "m128def.inc"	; uC tpus definicis file-ja 

.org	0x0		; kezdcm, innen indul a program, RESET vektor kezdete
	jmp start	; start cimkre elugrik
			; 0x0 cim s a 0x100 cm kztt a megszaktsok vannak
			; ezrt ezt a terletet ki kell hagyni (TILTOTT SV)
.org	0x100
start:
	nop		; nem csinl semmit (NO OPERATION)

	ldi r20, low (400)	; Els szm alacsony BYTE-ja (1_Low), MAJD a program kivlogatja
	ldi r21, high(400)	; Els szm magas BYTE-ja (1_Hi), MAJD a program kivlogatja

	ldi r22, low (300)	; Msodik szm alacsony BYTE-ja (2_Low), MAJD a program kivlogatja
	ldi r23, high(300)	; Msodik szm magas BYTE-ja (2_Hi), MAJD a program kivlogatja

				; tbb Byte-os sszeads ---- ---- ----
	add r20, r22		; als BYTE sima sszeadsa (1_Low+2_Low)
	adc r21, r23		; fels BYTE CARRY-s sszeadsa, 
				; als BYTE-tl kap CARRY-t is (CARRY+1_Hi+2_Hi)

stop:				; itt prg a progi a vgtelensgig
	jmp stop


; ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ====
; === 4. GYAKORL feladat =======================================================
;	- Irjon egy programot, mely 2 darab egyenknt 2 Byte-os szmot kivon egymsbl
;	- Nzze meg, hogy hol kpzdik az eredmny s rtkelje azt
;	- Prblja ki klnbz rtkekkel
; -------------------------------------------------------------------------------
;
; 	2 db. 2 BYTE-os szmok kivonsa kt flekppen
;
;		1. eset: tbb BYTE-os kivonssal, sbc-vel
;		
;		2. eset: kettes komplemens kpzssel s sszeadssal
;
;================================================================================

.include "m128def.inc"

.def szam1H=r23	; az els 2 BYTE-os szm 
.def szam1L=r22

.def szam2H=r25	; a msodik 2 BYTE-os szm
.def szam2L=r24

.def tmp=r16

.org 0x0
	jmp start
.org 0x100
start:

	ldi tmp, HIGH(RAMEND)
	out SPH, tmp
	ldi tmp, LOW (RAMEND)
	out SPL, tmp
	clr tmp


		; 1. eset (sbc hasznlatval) --------------------------
	ldi szam1H, HIGH(5400)	; az els 2 BYTE-os szm
	ldi szam1L, LOW (5400)
	ldi szam2H, HIGH(3200)	; a msodik 2 BYTE-os szm
	ldi szam2L, LOW (3200)

	clc
	sbc szam1L,szam2L
	sbc szam1H,szam2H

	nop	; 1. eset megoldsa ksz
	nop

		; 2. eset (kettes komplemens kpzssel s sszeadssal)
	ldi szam1H, HIGH(5400)	; az els 2 BYTE-os szm
	ldi szam1L, LOW (5400)
	ldi szam2H, HIGH(3200)	; a msodik 2 BYTE-os szm
	ldi szam2L, LOW (3200)

	com szam2H		; bitenknti negls (1-es komplemens)
	com szam2L
	adiw szam2H:szam2L, 1	; (2 BYTE-os szm egyes komplemens) +1

	clc
	adc szam1L,szam2L
	adc szam1H,szam2H

	nop	; 2. eset megoldsa ksz
vege:
	jmp vege




