;==============================================================================
;
;	2. rai AVR ASM 1. feladatrsz, progik 
;
;		- UGRSOK:
;
;			- felttel nlkli ugrs (pl.: JMP, RJMP)
;
;			- feltteles ugrsok (pl.: BRNE, BREQ, BRLT)
;
;	F7:      Assemble,		
;	Ctrl+F7: Assemble and Run
;	F11:	 Step
;
;------------------------------------------------------------------------------
;
;	DDRx  (8bit)	Data Direction (O:be, 1:ki) ( PORT irny bellits)
;	PORTx (8bit)	1 PORT kimeneti rtknek a belltsa (0: 0V, 1: 5V)
;	PINx  (1bit)	1 lb  kimeneti rtknek a belltsa (0: 0V, 1: 5V)
;
;==============================================================================

;==============================================================================
; 1. FELADAT: r17 regisztert vgtelensgig nveljk (vgtelen ciklus)
;
;	FONTOS: Lpsenknt az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;------------------------------------------------------------------------------

.include "m128def.inc"	; definicis file
.org 0x0
	rjmp start	; RELATV JUMP, 2K Byte cmet tud csak ugrani

.org 0x100
start:
	ldi r17, 0	; r17 regiszterbe 0-t tltnk

ciklus0:
	inc r17
	jmp ciklus0	; vgtelensgig prg 
			;    jmp: abszolt cmzs (teljes      cmtfogs), 
			;   rjmp: relatv  cmzs (korltozott cmtfogs)

vege:			; BAB
	jmp vege

;==============================================================================
; 2. FELADAT: 0-10-ig sszeadni a szmokat, regiszter elnevezssel
;
;	FONTOS: Lpsenknt az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;------------------------------------------------------------------------------

.include "m128def.inc"	; definicis file

.def osszeg=r16		; regiszter elnevezsek
.def i=r17

.org 0x0
	rjmp start	; RELATV JUMP, 2K Byte cmet tud csak ugrani

.org 0x100
start:	
	ldi osszeg, 0	; r16 reg., sszeg kezdetben 0 
	ldi i, 0	; r17 reg., segdvltoz
	
ciklus1:
	  inc i
	  add osszeg, i

	  cpi i, 0b00001010	; egy regisztert s egy szmot hasonlt ssze	
				; ugr utasts eltti vizsglat
	BRNE ciklus1		; ugrik a ciklus1-re, ha nem egyenl i<>szm, 
				; ami eltte van, annak az eredmnyt rtkeli ki
				; BRNE Z (zero) regisztert figyeli
	nop;
vege:
	jmp vege


;==============================================================================
; 3. GYAKORL FELADAT: 0-10-ig sszeadni a szmokat, regiszter elnevezssel
;
;	FONTOS: Lpsenknt az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;------------------------------------------------------------------------------

.include "m128def.inc"	; definicis file

.def osszeg=r16		; regiszter elnevezsek
.def i=r17
.def N=r18

.org 0x0
	rjmp start	; RELATV JUMP, 2K Byte cmet tud csak ugrani

.org 0x100
start:	
	ldi osszeg, 0
	ldi i, 0
	ldi N, 10

ciklus:
	  inc i
	  add osszeg, i

	  cp  i, N	    ; kt regisztert hasonlt ssze	
			    ; ugr utasts eltti vizsglat (KELL !!!)
	  BREQ ciklus_vege  ; ugrik a ciklus_vege cimkre, ha i=N, 
			    ; ami eltte van, annak az eredmnyt rtkeli ki
			    ; BREQ Z (zero) regisztert figyeli
	jmp ciklus

ciklus_vege:

	nop;
vege:
	jmp vege


;=================================================================================
; 4. FELADAT: rjon egy programot, mely OSZTS-t vizsgl 1 BYTE-os szmoknl 
;             (pl.1:  16/4,  pl.2:  16/5,  pl.3:  16/6)
;
;	FONTOS MEGJEGYZS: 
;	      - ebben az esetben a szmok 1 BYTE-osak, ami azt jelenti, hogy
;		az 1 BYTE-os szmokkal eljelesen nzve,  -128-tl  +127-ig 
;		tudunk rtket kifejezni!
;
;		Ezrt most, az (oktathat) egyszersg miatt az osztand szm s 
;		az oszt szm is csak  0  s  +127  kz essen. (!!!! !!!!)
;
;
;	      - legyen egy regiszter, ahol az egsz  rtk van a vgn feltntetve
;	      - legyen egy regiszter, ahol a maradk rtk van a vgn feltntetve
;
;	FONTOS: Lpsenknt az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;---------------------------------------------------------------------------------

.include "m128def.inc"	; definicis file

.def osztando=r16		; regiszter elnevezsek
.def oszto=r17
.def eredmeny_egesz=r18
.def eredmeny_maradek=r19

.org 0x0
	rjmp start	; RELATV JUMP, 2K Byte cmet tud csak ugrani

.org 0x100
start:	
	ldi osztando, 16
	ldi oszto, 4
	clr eredmeny_egesz
	clr eredmeny_maradek

ciklus:
	  inc eredmeny_egesz

	  sub osztando, oszto
	  BREQ eredmeny_oszthato	; ha oszthato
					; FONTOS: a feltteles ugr utastsok CSAK FIGYELIK a FLAG-eket,
					; DE nem lltjk a FLAG-eket!
					; Ezrt brmennyi feltteles ugr utasts llhat egyms utn.
	  BRMI eredmeny_nemoszthato 	; ha nem oszthato
	
	jmp ciklus
  
eredmeny_nemoszthato:			; ha negatvba futott az eredmny, akkor
	  dec eredmeny_egesz		; az utols kivons mr nem j, vissza kell lltani
	  add osztando, oszto 		; s a maradkot is
	  mov eredmeny_maradek, osztando
	  nop
	jmp vege

eredmeny_oszthato:			; ha nullba futott az eredmny, akkor minden OK
	mov eredmeny_maradek, osztando
	nop;

vege:
	jmp vege


;==============================================================================
; 5. GYAKORL FELADAT: Szorozzon ssze 2 db. 2 BYTE-os HEXADECIMLIS szmot! 
;	 Az els szm (szorzand) 2 Byte-os: (0xFFFF) 
;	 a  msodik szm (szorz) 2 Byte-os: (0xEEEE).
;
;	 VIGYZAT; 2 db. 2 BYTE-os szm tl fog csordulni 3. BYTE-ra
;			   s lehet, hogy a 4. BYTE-ra is!
;			   Ezrt az eredmny lehet akr 4 BYTE-os is! 
;			   Ezrt ismtelt CARRY hozzads szksges.
; 
; Szorzs visszavezetse ismtelt sszeadsra, annyiszor adjuk ssze 
; a szorzand szmot, ahnyszor meghatrozza a azt szorz, pl.: 3*10=10+10+10
;
; Krem, prbljk ki klnbz szmokkal s ellenrizzk az eredmnyt 
; szmolgppel (akr WINDOWS alatt is).
;
;	FONTOS: Lpsenknt az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;-------------------------------------------------------

.include "m128def.inc"

.def tmp=r16		; segdregiszter az 'adc'-hez

			; az eredmny 4 BYTE-os (lehet)
.def eredmeny_3B=r21	; az eredmny legfels 	3. BYTE-ja
.def eredmeny_2B=r20	; az eredmny		2. BYTE-ja 
.def eredmeny_1B=r19	; az eredmny		1. BYTE-ja
.def eredmeny_0B=r18	; az eredmny legals	0. BYTE-ja

.def sz1H=r23		; els szm (szorzand) 2 Byte-os
.def sz1L=r22

.def sz2H=r25		; msodik szm (szorz) 2 Byte-os
.def sz2L=r24

.org 0x0
    jmp start
.org 0x100
start:

	clr tmp;	; segdregiszter 'adc'-hez

			; az eredmny 4 BYTE-os (lehet)
	clr eredmeny_3B	; az eredmny legfels 	3. BYTE-ja
	clr eredmeny_2B	; az eredmny 		2. BYTE-ja 
	clr eredmeny_1B	; az eredmny 		1. BYTE-ja
	clr eredmeny_0B	; az eredmny legals	0. BYTE-ja

    ldi sz1L, low  (0xFFFF)	; 1. szm (szorzand) 2 BYTE-os
    ldi sz1H, high (0xFFFF)

    ldi sz2L, low  (0xEEEE)	; 2. szm (szorz)    2 BYTE-os
    ldi sz2H, high (0xEEEE)

ciklus:
	add eredmeny_0B, sz1L	; als BYTE-ok sszeadsa, CARRY nlkl
	adc eredmeny_1B, sz1H	; felsbb BYTE-ok sszedadsa, CARRY-vel
	adc eredmeny_2B, tmp	; tlcsorduls esetn; a 0+CARRY (ha van) hozzads az eredmny 2. BYTE-jhoz
	adc eredmeny_3B, tmp	; tlcsorduls esetn; a 0+CARRY (ha van) hozzads az eredmny 3. BYTE-jhoz

        sbiw sz2H:sz2L, 1 	; a msodik 2 BYTE-os (szorz) szmbl mindig kivonunk 1-et, 
				; addig, amg nulla nem lesz, hogy tudjuk, hogy hnyszor kell 
				; (mg) sszeadni az els (szorzand) szmot (pl.: 3*10=10+10+10)
				; FONTOS! sbiw (kt BYTE-os) utasts csak r25,r24 regiszterproson 
				; rtelmezett, tovbb a K konstans rtke csak 0 s +63 kz eshet.
				; Pldk:
				; sbiw sz2H:sz2L, K	; ahol   0 <= K <= 63
				; adiw sz2H:sz2L, K	; ahol   0 <= K <= 63

    brne ciklus		; nem kell a cpi utasts, mert brne a Z flag-et figyeli, s sbiw a Z flag-et lltja

vege:
    jmp vege
